define(["dojo/_base/declare",
		 "esri2/logging/Logger",
         "dojo/_base/xhr",
         "esri2/update/CheckboxTree",
         "dojo/aspect",
         "./ContentStoreJsonRest"],
		
 function(declare, Logger, xhr, CheckboxTree, aspect, ContentStoreJsonRest){
	

	var bisProvider = declare(null, {
		
		constructor: function(options){
					
			this.logPath= "cognos.update.BISPROVIDER";
			Logger.getSingleton().addLogPath( this.logPath, dojo.config.LogLevel);
		
			options = options || {};
			declare.safeMixin(this.options, options);
		},
		
		options: {},
		
		getProviderId: function () {
			return "Cognos";
		},
		
	    getRestEndpoint: function () {
			return dojo.config.em4cServer + "/updatews";
	    },
		
		getContentAsTree: function (handler, treeId, params){
			
			params = params || {};
			declare.safeMixin(this.options, params);
		
		 	var treeModel = new ContentStoreJsonRest(this.options);

		    var tree = new CheckboxTree({
				"class": "ContentTree",
				model: treeModel,
				showRoot : false,
		        getIconClass:   function( item, opened){
		    		return  treeModel.getIconClass(item, opened);
		    	} 
			}, treeId);
		    
		    handler.onSuccess (tree);
		},
		
		search4EMReports: function (handler, /*array*/ items) { 
		
			 var _searchPath = items[0].identifier;
			 
			 if(items[0].type!="report") {
				// search reports/folders under current folder/package
				_searchPath += "/*[permission('write')][@shown='true'][@objectClass='package' or @objectClass='folder' or @objectClass='report']";
			 }
			 
			 xhr.post({
					url: this.getRestEndpoint() + "/cognos/search4EM4CReports?",
					content: { 
						campassport: this.options.campassport,
						searchPath: encodeHTMLString(_searchPath)
					},
				    handleAs: "json"
				}).then(function(data){
					handler.onSuccess (data);
				}, function(error){
					handler.onFailure (error); 
				});		
		},
		
		/* upgradeEMReport: function (handler, item) {
			var _searchPath = item.identifier;
			
			xhr.post({
				url: this.getRestEndpoint()+ "/cognos/upgradeEM4CReport?",
				content: { 
					campassport: this.options.campassport,
					searchPath: _searchPath
				},
				handleAs: "json",
				load: function(data){
			 		handler.onSuccess (data);
				},
				error: function(error){
					handler.onFailure (error);
				}
			});
		}, */
		
		replaceMapServiceURL: function (handler, item, params) {
			var _searchPath = item.identifier;
	
			xhr.post({
				url: this.getRestEndpoint() + "/cognos/upgradeMapSpec?",
				content: { 
					campassport: this.options.campassport,
					searchPath: encodeHTMLString(_searchPath),
					oldurl:params.oldurl,
					newurl:params.newurl
				},
				handleAs: "json",
				load: function(data){
			 		handler.onSuccess (data);	
				},
				error: function(error){
					handler.onFailure (error);	
				}
			});
		}
		
	});
	return bisProvider;
});